package com.craftaro.ultimatestacker.api.stack.spawner;

import com.craftaro.core.third_party.com.cryptomorin.xseries.XMaterial;
import com.craftaro.ultimatestacker.api.utils.Hologramable;
import com.craftaro.ultimatestacker.api.utils.Stackable;
import com.craftaro.core.compatibility.CompatibleMaterial;
import com.craftaro.core.database.Data;
import com.craftaro.core.nms.world.SpawnedEntity;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.EntityType;

import java.util.Set;

public interface SpawnerStack extends Stackable, Hologramable, Data {

    int getAmount();

    boolean isValid();

    void setAmount(int amount);

    int calculateSpawnCount(EntityType type);

    int getId();

    void setId(int id);

    Location getLocation();

    String getHologramName();

    boolean areHologramsEnabled();

    int getX();

    int getY();

    int getZ();

    World getWorld();
    
    String getHologramId();

    int spawn(int amountToSpawn, EntityType... types);

    int spawn(int amountToSpawn, String particle, Set<XMaterial> canSpawnOn, SpawnedEntity spawned, EntityType... types);
}
